import { defineComponent } from 'vue'
import useLayoutStore from '../useLayoutStore'

export default defineComponent({
  setup() {
    const layout = useLayoutStore()
    return () => (
      <div class="absolute left-0 top-0 w-full h-screen z-0">
        {layout.background.video ? (
          <video src={layout.background.video} class="w-full h-full" />
        ) : (
          <div
            class="w-full h-full bg-center bg-cover bg-no-repeat"
            style={{
              backgroundImage: `url('${layout.background.image}')`
            }}
          ></div>
        )}
      </div>
    )
  }
})
