import { defineComponent } from 'vue'
import { OhVueIcon, addIcons } from 'oh-vue-icons'
import { FaUserAlt } from 'oh-vue-icons/icons'
import useUserStore from './useUserStore'

addIcons(FaUserAlt)

export default defineComponent(() => {
  const { profile } = useUserStore()
  return () => {
    return (
      <div
        class="w-full h-full rounded-full bg-black/20 flex justify-center items-center bg-center bg-no-repeat bg-cover"
        style={{
          backgroundImage: `url('${profile?.avatar}')`
        }}
      >
        {!profile.avatar && <OhVueIcon name="fa-user-alt" fill="white" scale={1.2} />}
      </div>
    )
  }
})
