import { ConfigProvider, theme } from 'ant-design-vue'
import { defineComponent } from 'vue'
import zhCN from 'ant-design-vue/es/locale/zh_CN'

export default defineComponent({
  props: {
    dark: {
      type: Boolean,
      default: false
    }
  },
  setup(props, ctx) {
    return () => (
      <ConfigProvider
        theme={{
          algorithm: props.dark ? theme.darkAlgorithm : theme.defaultAlgorithm,
          token: {
            colorPrimary: '#f7a94e',
            colorBgBase: props.dark ? '#393a41' : '#fff',
            colorBorder: 'transparent'
          }
        }}
        locale={zhCN}
      >
        {ctx.slots.default?.()}
      </ConfigProvider>
    )
  }
})
