import { ossBase } from './../config'
import OSS from 'ali-oss'
import { v4 as uuid } from 'uuid'
import request from './request'
export default async function upload(file: File, root: string) {
  const token = localStorage.getItem('token')
  if (!token) {
    throw new Error('尚未登录，无法上传')
  }
  const config = await request<{
    region: string
    accessKeyId: string
    accessKeySecret: string
    securityToken: string
    bucket: string
    path: string
  }>('POST', '/api/ossKey')
  const ext = file.name.split('.').pop()
  const path = `${config.path}/${root}/${uuid()}.${ext}`
  const client = new OSS({
    region: config.region,
    accessKeyId: config.accessKeyId,
    accessKeySecret: config.accessKeySecret,
    stsToken: config.securityToken,
    bucket: config.bucket
  })
  const { name } = await client.put(path, file, {
    mime: file.type,
    headers: {
      'Content-Type': file.type
    }
  })
  return ossBase + '/' + name
}
